"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("@openapi-generator-plus/types");
const path_1 = __importDefault(require("path"));
const handlebars_templates_1 = require("@openapi-generator-plus/handlebars-templates");
const typescript_generator_common_1 = __importDefault(require("@openapi-generator-plus/typescript-generator-common"));
const createGenerator = (context) => {
    const base = typescript_generator_common_1.default(Object.assign(Object.assign({}, context), { loadAdditionalTemplates: async (hbs) => {
            await handlebars_templates_1.loadTemplates(path_1.default.resolve(__dirname, '../templates'), hbs);
        }, additionalWatchPaths: () => {
            return [path_1.default.resolve(__dirname, '../templates')];
        }, additionalExportTemplates: async (outputPath, doc, hbs, rootContext, state) => {
            const relativeSourceOutputPath = state.options.relativeSourceOutputPath;
            await handlebars_templates_1.emit('api', path_1.default.join(outputPath, relativeSourceOutputPath, 'api.ts'), Object.assign(Object.assign(Object.assign({}, doc), state.options), rootContext), true, hbs);
            await handlebars_templates_1.emit('models', path_1.default.join(outputPath, relativeSourceOutputPath, 'models.ts'), Object.assign(Object.assign(Object.assign({}, doc), state.options), rootContext), true, hbs);
            await handlebars_templates_1.emit('runtime', path_1.default.join(outputPath, relativeSourceOutputPath, 'runtime.ts'), Object.assign(Object.assign(Object.assign({}, doc), state.options), rootContext), true, hbs);
            await handlebars_templates_1.emit('configuration', path_1.default.join(outputPath, relativeSourceOutputPath, 'configuration.ts'), Object.assign(Object.assign(Object.assign({}, doc), state.options), rootContext), true, hbs);
            await handlebars_templates_1.emit('custom.d', path_1.default.join(outputPath, relativeSourceOutputPath, 'custom.d.ts'), Object.assign(Object.assign(Object.assign({}, doc), state.options), rootContext), true, hbs);
            await handlebars_templates_1.emit('index', path_1.default.join(outputPath, relativeSourceOutputPath, 'index.ts'), Object.assign(Object.assign(Object.assign({}, doc), state.options), rootContext), true, hbs);
            await handlebars_templates_1.emit('README', path_1.default.join(outputPath, 'README.md'), Object.assign(Object.assign(Object.assign({}, doc), state.options), rootContext), true, hbs);
        }, transformOptions: (config, options) => {
            const result = Object.assign({}, options);
            return result;
        }, defaultNpmOptions: () => ({
            name: 'typescript-fetch-api',
            version: '0.0.1',
        }), defaultTypeScriptOptions: () => ({
            target: 'ES5',
            libs: ['$target', 'DOM'],
        }), generatorClassName: () => '@openapi-generator-plus/typescript-fetch-client-generator' }));
    return Object.assign(Object.assign({}, base), { generatorType: () => types_1.CodegenGeneratorType.CLIENT });
};
exports.default = createGenerator;
